#include "Globals.h"

int Globals::GAME_WIDTH = 320;
int Globals::GAME_HEIGHT = 180;
int Globals::GAME_SCALE = 4;
float Globals::RENDER_THRESHOLD = 1.0f / 60.0f;

int Globals::NUM_DOMES = 5;
float Globals::PART_LIFE = 1.0f;

NImage Globals::Backbuffer1;
NImage Globals::Backbuffer2;
NImage* Globals::Backbuffer;

NImage Globals::Backdrop;

NImage Globals::MailOut;

MaskedImage Globals::Numerals;
MaskedImage Globals::BlackHole;

std::vector<std::vector<Thing*> > Globals::Objects;

HWND Globals::gWnd = NULL;
HDC Globals::gDC = NULL;

Sound Globals::Sound_Compose;
Sound Globals::Sound_MailIn;
Sound Globals::Sound_MailOut;
Sound Globals::Sound_Success;
Sound Globals::Sound_Strike;
Sound Globals::Sound_TooSlow;
Sound Globals::Sound_Vortex;

float Globals::LastRenderTime = -Globals::RENDER_THRESHOLD;

float Globals::SORT_THRESHOLD = 2.0f;
float Globals::LastSortTime = -1000.0f;

float Globals::COMPOSE_THRESHOLD_MAX = 4.0f;
float Globals::COMPOSE_THRESHOLD_MIN = Globals::COMPOSE_THRESHOLD_MAX;
float Globals::COMPOSE_THRESHOLD_DROP = 0.2f;
float Globals::COMPOSE_THRESHOLD_LOWEST = 1.0f;
float Globals::NextComposeTime = Globals::COMPOSE_THRESHOLD_MAX;

Thing* Globals::Dragging;
NVec2 Globals::DragOffset;

std::vector<Particle> Globals::InParticles;
std::vector<Particle> Globals::OutParticles;

int Globals::GRACE_ADDRESSES = 6;

int Globals::MAX_MAIL_IN_FLIGHT = 8;

int Globals::DELIVERY_SUCCESSES = 0;
int Globals::DELIVERY_FAILURES = 0;
int Globals::DELIVERY_SATISFIED = 0;
int Globals::DELIVERY_UNSATISFIED = 0;
int Globals::DELIVERY_TOTAL_COUNT = 0;
float Globals::DELIVERY_TOTAL_TIME = 0.0f;

float Globals::DELIVERY_TIME_LIMIT = 20.0f;

float Globals::GAME_TIME_LIMIT = 135.0f;

bool Globals::GAME_STARTED = false;
bool Globals::GAME_OVER = false;
