#pragma once

#include "NWindowsVersion.h"
#include "NUtilDefs.h"

#include <shlobj.h>
#include <shlwapi.h>

static inline void GetWorkingDirectory(char* Buffer, size_t BufferLen)
{
	GetCurrentDirectory((DWORD)BufferLen, Buffer);
}

static inline void SetWorkingDirectory(const char* Buffer)
{
	SetCurrentDirectory(Buffer);
}

static inline void GetExecutableDirectory(char* Buffer, size_t BufferLen)
{
	GetModuleFileName(NULL, Buffer, (DWORD)BufferLen);
	PathRemoveFileSpec(Buffer);
}
